Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkMarchingContourFilter Class Reference

`#include <vtkMarchingContourFilter.h>`

Inheritance diagram for vtkMarchingContourFilter:

[legend]
Collaboration diagram for vtkMarchingContourFilter:

[legend]
List of all members.

## Detailed Description

generate isosurfaces/isolines from scalar values

Date:
  2002/09/30 20:35:19

Revision:
  1.21

vtkMarchingContourFilter is a filter that takes as input any dataset and generates on output isosurfaces and/or isolines. The exact form of the output depends upon the dimensionality of the input data. Data consisting of 3D cells will generate isosurfaces, data consisting of 2D cells will generate isolines, and data with 1D or 0D cells will generate isopoints. Combinations of output type are possible if the input dimension is mixed.

This filter will identify special dataset types (e.g., structured points) and use the appropriate specialized filter to process the data. For examples, if the input dataset type is a volume, this filter will create an internal vtkMarchingCubes instance and use it. This gives much better performance.

To use this filter you must specify one or more contour values. You can either use the method SetValue() to specify each contour value, or use GenerateValues() to generate a series of evenly spaced contours. It is also possible to accelerate the operation of this filter (at the cost of extra memory) by using a vtkScalarTree. A scalar tree is used to quickly locate cells that contain a contour surface. This is especially effective if multiple contours are being extracted. If you want to use a scalar tree, invoke the method UseScalarTreeOn().

Warning:
  For unstructured data or structured grids, normals and gradients are not computed. This calculation will be implemented in the future. In the mean time, use vtkPolyDataNormals to compute the surface normals.

See also:
  vtkMarchingCubes vtkSliceCubes vtkDividingCubes vtkMarchingSquares vtkImageMarchingCubes

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (72%)
  - Schroeder, Will (9%)
  - Henderson, Amy (5%)

CVS logs (CVSweb):
  - .`h` (`/Patented/vtkMarchingContourFilter.h)`
  - .`cxx` (`/Patented/vtkMarchingContourFilter.cxx)`

Tests:
  vtkMarchingContourFilter (Tests)

Definition at line 97 of file vtkMarchingContourFilter.h.

## Public Types
typedef vtkDataSetToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long | GetMTime ()
void | CreateDefaultLocator ()
void | SetValue (int i, float value)
float | GetValue (int i)
float * | GetValues ()
void | GetValues (float *contourValues)
void | SetNumberOfContours (int number)
int | GetNumberOfContours ()
void | GenerateValues (int numContours, float range[2])
void | GenerateValues (int numContours, float rangeStart, float rangeEnd)
virtual void | SetComputeNormals (int)
virtual int | GetComputeNormals ()
virtual void | ComputeNormalsOn ()
virtual void | ComputeNormalsOff ()
virtual void | SetComputeGradients (int)
virtual int | GetComputeGradients ()
virtual void | ComputeGradientsOn ()
virtual void | ComputeGradientsOff ()
virtual void | SetComputeScalars (int)
virtual int | GetComputeScalars ()
virtual void | ComputeScalarsOn ()
virtual void | ComputeScalarsOff ()
virtual void | SetUseScalarTree (int)
virtual int | GetUseScalarTree ()
virtual void | UseScalarTreeOn ()
virtual void | UseScalarTreeOff ()
void | SetLocator (vtkPointLocator *locator)
virtual vtkPointLocator * | GetLocator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkMarchingContourFilter * | SafeDownCast (vtkObject *o)
vtkMarchingContourFilter * | New ()
## Protected Methods
| vtkMarchingContourFilter ()
| ~vtkMarchingContourFilter ()
void | Execute ()
void | StructuredPointsContour (int dim)
void | ImageContour (int dim)
void | DataSetContour ()
## Protected Attributes
vtkContourValues * | ContourValues
int | ComputeNormals
int | ComputeGradients
int | ComputeScalars
vtkPointLocator * | Locator
int | UseScalarTree
vtkScalarTree * | ScalarTree

## Member Typedef Documentation

typedef vtkDataSetToPolyDataFilter vtkMarchingContourFilter::Superclass

| Reimplemented from vtkDataSetToPolyDataFilter. Definition at line 100 of file vtkMarchingContourFilter.h.

## Constructor & Destructor Documentation

vtkMarchingContourFilter::vtkMarchingContourFilter | ( |  | ) | `[protected]`

vtkMarchingContourFilter::~vtkMarchingContourFilter | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkMarchingContourFilter::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataSetToPolyDataFilter.

int vtkMarchingContourFilter::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToPolyDataFilter.

virtual int vtkMarchingContourFilter::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToPolyDataFilter.

vtkMarchingContourFilter* vtkMarchingContourFilter::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataSetToPolyDataFilter.

void vtkMarchingContourFilter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataSetToPolyDataFilter.

vtkMarchingContourFilter* vtkMarchingContourFilter::New | ( |  | ) | `[static]`

| Construct object with initial range (0,1) and single contour value of 0.0. Reimplemented from vtkObject.

void vtkMarchingContourFilter::SetValue | ( | int | i,
|  | float | value
| ) | `[inline]`

| Methods to set / get contour values. Definition at line 196 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::SetValue().

float vtkMarchingContourFilter::GetValue | ( | int | i | ) | `[inline]`

| Get the ith contour value. Definition at line 202 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GetValue().

float * vtkMarchingContourFilter::GetValues | ( |  | ) | `[inline]`

| Get a pointer to an array of contour values. There will be GetNumberOfContours() values in the list. Definition at line 209 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GetValues().

void vtkMarchingContourFilter::GetValues | ( | float * | contourValues | ) | `[inline]`

| Fill a supplied list with contour values. There will be GetNumberOfContours() values in the list. Make sure you allocate enough memory to hold the list. Definition at line 217 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GetValues().

void vtkMarchingContourFilter::SetNumberOfContours | ( | int | number | ) | `[inline]`

| Set the number of contours to place into the list. You only really need to use this method to reduce list size. The method SetValue() will automatically increase list size as needed. Definition at line 225 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::SetNumberOfContours().

int vtkMarchingContourFilter::GetNumberOfContours | ( |  | ) | `[inline]`

| Get the number of contours in the list of contour values. Definition at line 231 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GetNumberOfContours().

void vtkMarchingContourFilter::GenerateValues | ( | int | numContours,
|  | float | range[2]
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 239 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GenerateValues().

void vtkMarchingContourFilter::GenerateValues | ( | int | numContours,
|  | float | rangeStart,
|  | float | rangeEnd
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 249 of file vtkMarchingContourFilter.h. References ContourValues, and vtkContourValues::GenerateValues().

unsigned long vtkMarchingContourFilter::GetMTime | ( |  | ) | `[virtual]`

| Modified GetMTime Because we delegate to vtkContourValues Reimplemented from vtkObject.

virtual void vtkMarchingContourFilter::SetComputeNormals | ( | int |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkMarchingContourFilter::GetComputeNormals | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::ComputeNormalsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::ComputeNormalsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::SetComputeGradients | ( | int |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkMarchingContourFilter::GetComputeGradients | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::ComputeGradientsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::ComputeGradientsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkMarchingContourFilter::SetComputeScalars | ( | int |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual int vtkMarchingContourFilter::GetComputeScalars | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkMarchingContourFilter::ComputeScalarsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkMarchingContourFilter::ComputeScalarsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkMarchingContourFilter::SetUseScalarTree | ( | int |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual int vtkMarchingContourFilter::GetUseScalarTree | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual void vtkMarchingContourFilter::UseScalarTreeOn | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual void vtkMarchingContourFilter::UseScalarTreeOff | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

void vtkMarchingContourFilter::SetLocator | ( | vtkPointLocator * | locator | ) |

| Set / get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

virtual vtkPointLocator* vtkMarchingContourFilter::GetLocator | ( |  | ) | `[virtual]`

| Set / get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

void vtkMarchingContourFilter::CreateDefaultLocator | ( |  | ) |

| Create default locator. Used to create one when none is specified. The locator is used to merge coincident points.

void vtkMarchingContourFilter::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkMarchingContourFilter::StructuredPointsContour | ( | int | dim | ) | `[protected]`

void vtkMarchingContourFilter::ImageContour | ( | int | dim | ) | `[protected]`

void vtkMarchingContourFilter::DataSetContour | ( |  | ) | `[protected]`

## Member Data Documentation

vtkContourValues* vtkMarchingContourFilter::ContourValues`[protected]`

| Definition at line 175 of file vtkMarchingContourFilter.h. Referenced by GenerateValues(), GetNumberOfContours(), GetValue(), GetValues(), SetNumberOfContours(), and SetValue().

int vtkMarchingContourFilter::ComputeNormals`[protected]`

| Definition at line 176 of file vtkMarchingContourFilter.h.

int vtkMarchingContourFilter::ComputeGradients`[protected]`

| Definition at line 177 of file vtkMarchingContourFilter.h.

int vtkMarchingContourFilter::ComputeScalars`[protected]`

| Definition at line 178 of file vtkMarchingContourFilter.h.

vtkPointLocator* vtkMarchingContourFilter::Locator`[protected]`

| Definition at line 179 of file vtkMarchingContourFilter.h.

int vtkMarchingContourFilter::UseScalarTree`[protected]`

| Definition at line 180 of file vtkMarchingContourFilter.h.

vtkScalarTree* vtkMarchingContourFilter::ScalarTree`[protected]`

| Definition at line 181 of file vtkMarchingContourFilter.h.

The documentation for this class was generated from the following file:

- Patented/vtkMarchingContourFilter.h